%global momorel 8
%global srcname %{name}-source

Summary: K-3D open-source 3D modeling, animation, and rendering system
Name: k3d
Version: 0.7.11.0
Release: %{momorel}m%{?dist}
License: GPLv2+
Group: Applications/Multimedia
URL: http://www.k-3d.org/
Source0: http://dl.sourceforge.net/sourceforge/%{name}/%{srcname}-%{version}.tar.gz
NoSource: 0
Source1: %{name}.desktop
# patches from cooker
Patch0: %{name}-%{version}-fix-potfiles.patch
Patch1: %{name}-%{version}-libdl.patch
Patch2: %{name}-%{version}-glx-linkage.patch
# a patch from Fedora
Patch10: %{name}-%{version}-sigc.patch
# momonga's patch
Patch20: %{name}-%{version}-gcc44.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires: aqsis
Requires: yafray
# reserved
# Requires: povray
BuildRequires: CGAL-devel >= 3.6
BuildRequires: ImageMagick
BuildRequires: ImageMagick-c++-devel >= 6.6.2.10
BuildRequires: OpenEXR-devel >= 1.6.1
BuildRequires: boost-devel >= 1.43.0
BuildRequires: bzip2-devel
BuildRequires: chrpath
BuildRequires: cmake
BuildRequires: coreutils
BuildRequires: doxygen
BuildRequires: e2fsprogs-devel
BuildRequires: expat-devel
BuildRequires: freetype-devel
BuildRequires: glew-devel
BuildRequires: gnome-vfs2-devel
BuildRequires: graphviz-devel
BuildRequires: gtkglext-devel
BuildRequires: gtkmm-devel
BuildRequires: gts-devel
BuildRequires: libjpeg-devel >= 8a
BuildRequires: libpng-devel
BuildRequires: librsvg2-devel >= 2.22.2-3m
BuildRequires: libsigc++-devel >= 2.1.1
BuildRequires: libtiff-devel
BuildRequires: libuuid-devel
BuildRequires: mesa-libGL-devel
BuildRequires: plib
BuildRequires: python-devel >= 2.5

%description
K-3D is the free-as-in-freedom 3D modeling, animation, and rendering 
system for GNU / Linux, Posix, and Win32 operating systems. K-3D features a 
robust, object-oriented plugin architecture, designed to scale to the needs of 
professional artists, and is designed from-the-ground-up to generate 
motion-picture-quality animation using RenderMan-compliant render engines.

%package devel
Summary: Headers for rendering models written by K-3D
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the libraries and header files needed for
rendering a model written by K-3D.

%prep
%setup -q -n %{srcname}-%{version}

%patch0 -p1 -b .pot
%patch1 -p1 -b .dl
%patch2 -p0 -b .gfx
%patch10 -p1 -b .sigc++
%patch20 -p1 -b .gcc44~

rm -f CMakeCache.txt

%build
export LD_LIBRARY_PATH=%{_builddir}/%{srcname}-%{version}/%{_target_platform}/%{_lib}:$LD_LIBRARY_PATH

mkdir -p %{_target_platform}
pushd %{_target_platform}
%cmake \
	-DK3D_BUILD_GTS_MODULE:BOOL=ON \
	..
popd

make %{?_smp_mflags} -C %{_target_platform} VERBOSE=1

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
make install DESTDIR=%{buildroot} -C %{_target_platform}

# install desktop file
mkdir -p %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/applications/

# install icons
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/{16x16,22x22,32x32,48x48,64x64,128x128}/apps
convert -scale 16x16 share/icons/%{name}.png %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
convert -scale 22x22 share/icons/%{name}.png %{buildroot}%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
convert -scale 32x32 share/icons/%{name}.png %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -m 644 share/icons/%{name}.png %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
convert -scale 64x64 share/icons/%{name}_large.png %{buildroot}%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
convert -scale 128x128 share/icons/%{name}_large.png %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/%{name}.png

# link icon
mkdir -p %{buildroot}%{_datadir}/pixmaps
ln -s ../icons/hicolor/48x48/apps/%{name}.png %{buildroot}%{_datadir}/pixmaps/%{name}.png

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
/sbin/ldconfig
%{_bindir}/update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :

%postun
/sbin/ldconfig
%{_bindir}/update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :

%files
%defattr(-, root, root)
%doc AUTHORS COPYING INSTALL README
%{_bindir}/%{name}
%{_bindir}/%{name}-renderframe
%{_bindir}/%{name}-renderjob
%{_bindir}/%{name}-sl2xml
%{_bindir}/%{name}-uuidgen
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/plugins
%{_libdir}/%{name}/uiplugins
# these are not links
%{_libdir}/lib%{name}sdk*.so
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/*/apps/%{name}.png
%{_datadir}/%{name}
%{_mandir}/man1/%{name}.1*
%{_datadir}/pixmaps/%{name}.png

%files devel
%defattr(-, root, root)
%{_includedir}/%{name}
%{_libdir}/%{name}/include

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.7.11.0-8m)
- full rebuild for mo7 release

* Sat Jul 31 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.7.11.0-7m)
- revert to version 0.7.11.0
- can not build version 0.8.0.1 on x86_64

* Sat Jul 31 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.8.0.1-1m)
- version 0.8.0.1
- remove k3d-google-perftools.module to avoid crashing
- clean up patches

* Mon Jul  5 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.7.11.0-6m)
- rebuild against ImageMagick-6.6.2.10

* Sun Jun 27 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (0.7.11.0-5m)
- add BuildRequires: CGAL-devel >= 3.6.0

* Fri Jun 25 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.7.11.0-4m)
- rebuild against boost-1.43.0

* Sat Apr 10 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.7.11.0-3m)
- rebuild against libjpeg-8a

* Wed Mar  3 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.7.11.0-2m)
- rebuild against ImageMagick-6.5.9.10

* Sun Dec 13 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.7.11.0-1m)
- version 0.7.11.0
- import 3 patches from cooker
 - k3d-0.7.11.0-fix-potfiles.patch
 - k3d-0.7.11.0-libdl.patch
 - k3d-0.7.11.0-glx-linkage.patch
- update sigc.patch and gcc44.patch
- remove gcc43.patch
- good-bye autotools and hello cmake!

* Sun Nov 29 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.6.7.0-26m)
- rebuild agaisnt boost-1.41.0

* Sun Nov 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.6.7.0-25m)
- rebuild against gcc-4.4 and glibc-2.11

* Tue Oct 13 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.7.0-24m)
- rebuild agaisnt boost-1.40.0

* Thu Sep 10 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.6.7.0-23m)
- rebuild against libjpeg-7

* Mon May 18 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.7.0-22m)
- fix build with new libtool

* Sun May 17 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.6.7.0-21m)
- rebuilt for boost-1.39.0

* Tue Jan 27 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.6.7.0-20m)
- apply gcc44 patch and sed script

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.6.7.0-19m)
- rebuild against rpm-4.6

* Thu Jan 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.6.7.0-18m)
- rebuild against boost-1.37.0
- License: GPLv2+

* Mon Jan 12 2009 NARITA Koichi <pulsar@momonga-linux.org>
- (0.6.7.0-17m)
- rebuild against ImageMagick-6.4.8.5-1m

* Thu Jan  1 2009 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.6.7.0-16m)
- rebuild against python-2.6.1-2m

* Sun Jul 13 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.6.7.0-15m)
- rebuild against ImageMagick-6.4.2.1

* Sun Jul  6 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.6.7.0-14m)
- rebuild against graphviz-2.18

* Tue Apr 29 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.6.7.0-13m)
- rebuild against librsvg2-2.22.2-3m

* Sun Apr  6 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.7.0-12m)
- build with external-boost on x86_64 again

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.6.7.0-11m)
- rebuild against gcc43

* Thu Mar 27 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.7.0-10m)
- rebuild against OpenEXR-1.6.1

* Thu Feb 14 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.6.7.0-9m)
- %%NoSource -> NoSource

* Thu Feb  7 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.6.7.0-8m)
- add gcc43.patch 
- add -fpermissive for gcc43

* Sun Dec  2 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.6.7.0-7m)
- move libk3dngui.so from devel to main

* Sun Sep 23 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (0.6.7.0-6m)
- add patch11 for libsigc++-2.1.1

* Thu Aug 30 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.7.0-5m)
- build without external-boost on x86_64 for the moment

* Thu Aug 16 2007 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.6.7.0-4m)
- rebuild against boost-1.34.1-1m

* Tue Aug 14 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.6.7.0-1m)
- update to 0.6.7.0

* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.6.0-3m)
- BuildRequires: freetype2-devel -> freetype-devel

* Wed Mar  7 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.6.0-2m)
- Requires: aqsis, yafray

* Wed Mar  7 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.6.6.0-1m)
- initial package for Momonga Linux
